// openwithnotepadShl.h : Declaration of the CopenwithnotepadShl

#ifndef __openwithnotepadSHL_H_
#define __openwithnotepadSHL_H_

#include "resource.h"       // main symbols
#include <shlobj.h>
#include <comdef.h>

/////////////////////////////////////////////////////////////////////////////
// CopenwithnotepadShl
class ATL_NO_VTABLE CopenwithnotepadShl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CopenwithnotepadShl, &CLSID_openwithnotepadShl>,
	public IDispatchImpl<IopenwithnotepadShl, &IID_IopenwithnotepadShl, &LIBID_openwithnotepadLib>,
	public IShellExtInit,
	public IContextMenu
{
public:
	CopenwithnotepadShl();

DECLARE_REGISTRY_RESOURCEID(IDR_openwithnotepadSHL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CopenwithnotepadShl)
	COM_INTERFACE_ENTRY(IopenwithnotepadShl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IShellExtInit)
	COM_INTERFACE_ENTRY(IContextMenu)
END_COM_MAP()

// IopenwithnotepadShl
public:
    // IShellExtInit
    STDMETHOD(Initialize)(LPCITEMIDLIST, LPDATAOBJECT, HKEY);

    // IContextMenu
    STDMETHOD(GetCommandString)(UINT_PTR, UINT, UINT*, LPSTR, UINT);
    STDMETHOD(InvokeCommand)(LPCMINVOKECOMMANDINFO);
    STDMETHOD(QueryContextMenu)(HMENU, UINT, UINT, UINT, UINT);

protected:
	HRESULT SendToNotepad();

protected:
    string_list m_lsFiles;
	HBITMAP     m_hNotepadBmp;
};

#endif //__openwithnotepadSHL_H_
